unit unit_TestProjekt;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  SliderComponent,LCLIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    BigMarks: TButton;
    ScaleStyle: TButton;
    SelColor: TButton;
    ExtraColor: TButton;
    SetWH: TButton;
    Knob3: TButton;
    Knob2: TButton;
    SliderComponent1: TSliderComponent;
    SliderHeight: TLabeledEdit;
    SliderWidth: TLabeledEdit;
    SwapColors: TButton;
    OtherSide: TButton;
    Scale: TButton;
    Mark2: TButton;
    Mark1: TButton;
    Indicator: TButton;
    KnopStyle: TButton;
    Reversed: TButton;
    Orientation: TButton;
    Label1: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    RadioGroup1: TRadioGroup;
    procedure BigMarksClick(Sender: TObject);
    procedure ExtraColorClick(Sender: TObject);
    procedure Knob2Click(Sender: TObject);
    procedure IndicatorClick(Sender: TObject);
    procedure Knob3Click(Sender: TObject);
    procedure KnopStyleClick(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Mark1Click(Sender: TObject);
    procedure Mark2Click(Sender: TObject);
    procedure OtherSideClick(Sender: TObject);
    procedure ReversedClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure OrientationClick(Sender: TObject);
    procedure ScaleClick(Sender: TObject);
    procedure ScaleStyleClick(Sender: TObject);
    procedure SelColorClick(Sender: TObject);
    procedure SetWHClick(Sender: TObject);
    procedure SliderComponent1Change(const Count: integer);
    procedure SwapColorsClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  KT   : integer;
  theme: boolean;
implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
 self.Caption   := 'Test the SliderComponent';
 Label1.Caption := 'Slider Position: '+ inttostr(SliderComponent1.Position);

 with SliderComponent1 do
  begin
   width     := 200;
   height    :=  30;
   RangeMin  :=   0;
   RangeMax  := 200;
  end;
 KT :=0;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 if RadioGroup1.ItemIndex =0 then  //Positiv
  begin
   SliderComponent1.RangeMin:=   0;
   SliderComponent1.RangeMax:= 200;
   SliderComponent1.Mark.MarkPosition := 20;
   SliderComponent1.Mark.Mark2Position:=180;
   SliderComponent1.MultiKnob.PosKnob2:= 20;
   SliderComponent1.MultiKnob.PosKnob3:= 40;
   SliderComponent1.Track.ExtraRangeMin:=180;
   SliderComponent1.Track.ExtraRangeMax:=200;
  end;
 if RadioGroup1.ItemIndex =1 then  //Negativ
  begin
   SliderComponent1.RangeMin:= -200;
   SliderComponent1.RangeMax:=    0;
   SliderComponent1.Mark.MarkPosition :=  0;
   SliderComponent1.Mark.Mark2Position:=-180;
   SliderComponent1.MultiKnob.PosKnob2:= -20;
   SliderComponent1.MultiKnob.PosKnob3:= -40;
   SliderComponent1.Track.ExtraRangeMin:=-200;
   SliderComponent1.Track.ExtraRangeMax:=-180;
  end;
 if RadioGroup1.ItemIndex =2 then  //Positiv/Negativ
  begin
   SliderComponent1.RangeMin:= -100;
   SliderComponent1.RangeMax:=  100;
   SliderComponent1.Mark.MarkPosition := 80;
   SliderComponent1.Mark.Mark2Position:=-80;
   SliderComponent1.MultiKnob.PosKnob2:= 20;
   SliderComponent1.MultiKnob.PosKnob3:= 20;
   SliderComponent1.Track.ExtraRangeMin:=-100;
   SliderComponent1.Track.ExtraRangeMax:=0;
  end;
end;

procedure TForm1.OrientationClick(Sender: TObject);
var t:string;
begin
 if   SliderComponent1.Orientation = scVertical then SliderComponent1.Orientation:= scHorizontal
 else SliderComponent1.Orientation:= scVertical;
 RadioGroup1Click(Orientation);
 t:= SliderWidth.Text;
 SliderWidth.Text:= SliderHeight.Text;
 SliderHeight.Text:= t;
end;

procedure TForm1.ReversedClick(Sender: TObject);
begin
 if   SliderComponent1.Reversed = true then
  begin
   SliderComponent1.Reversed:= false;
   Reversed.Caption:='Reversed [false]';
  end
  else
  begin
   SliderComponent1.Reversed:= true;
   Reversed.Caption:='Reversed [true]';
  end;
  RadioGroup1Click(nil);
end;

procedure TForm1.KnopStyleClick(Sender: TObject);
begin
 inc(KT);
 case KT of
  0: begin
      SliderComponent1.KnobLook := klNormal;
      SliderComponent1.KnobStyle:= ksCircle;
     end;
  1: SliderComponent1.KnobStyle:= ksRectangle;
  2: SliderComponent1.KnobStyle:= ksRoundrect;
  3: SliderComponent1.KnobStyle:= ksArrowUp;   //right
  4: SliderComponent1.KnobStyle:= ksArrowDown; //left
  5: begin
      SliderComponent1.KnobLook:=klRipped;
      SliderComponent1.KnobStyle:= ksCircle;
     end;
  6: SliderComponent1.KnobStyle:= ksRectangle;
  7: SliderComponent1.KnobStyle:= ksRoundrect;
  8: SliderComponent1.KnobStyle:= ksArrowUp;   //right
  9: SliderComponent1.KnobStyle:= ksArrowDown; //left
 end;
 if KT=9 then KT:=-1;
end;

procedure TForm1.Label1Click(Sender: TObject);
begin

end;

procedure TForm1.IndicatorClick(Sender: TObject);
begin
 if   SliderComponent1.Indicator.IndicatorVisible = true then SliderComponent1.Indicator.IndicatorVisible:= false
 else SliderComponent1.Indicator.IndicatorVisible:= true;
 RadioGroup1Click(nil);
end;

procedure TForm1.Mark1Click(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if Mark.MarkVisible=true then Mark.MarkVisible:=false
   else Mark.MarkVisible:=true;
   RadioGroup1Click(nil);
  end;
end;

procedure TForm1.Mark2Click(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if Mark.Mark2Visible=true then Mark.Mark2Visible:=false
   else Mark.Mark2Visible:=true;
   RadioGroup1Click(nil);
  end;
end;

procedure TForm1.ScaleClick(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if Scale.ShowScale=true then Scale.ShowScale:=false
   else Scale.ShowScale:=true;
  SliderComponent1.Scale.Interval:=10;
  end;
end;

procedure TForm1.ScaleStyleClick(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if Scale.ScaleStyle =ssCircle then Scale.ScaleStyle :=ssDash
   else Scale.ScaleStyle :=ssCircle;
  end;
end;

procedure TForm1.BigMarksClick(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if Scale.ShowBigMark=true then Scale.ShowBigMark:=false
   else Scale.ShowBigMark:=true;
  end;
 SliderComponent1.Scale.BigMarkInterval:=50;
 SliderComponent1.Scale.BigMarkSize:=1.4;
end;

procedure TForm1.SliderComponent1Change(const Count: integer);
begin
 Label1.Caption := 'Slider Position: '+ inttostr(Count);

 if SliderComponent1.MultiKnob.ShowKnob2 then
 Label1.Caption := 'Slider Position: '+ inttostr(Count) +
 '   Knob2: '+inttostr(SliderComponent1.MultiKnob.PosKnob2);

 if SliderComponent1.MultiKnob.ShowKnob3 then
 Label1.Caption := 'Slider Position: '+ inttostr(Count) +
 '   Knob3: '+inttostr(SliderComponent1.MultiKnob.PosKnob3);

 if (SliderComponent1.MultiKnob.ShowKnob2 and SliderComponent1.MultiKnob.ShowKnob3) then
 Label1.Caption := 'Slider Position: '+ inttostr(Count) +
 '   Knob2: '+inttostr(SliderComponent1.MultiKnob.PosKnob2)+
 '   Knob3: '+inttostr(SliderComponent1.MultiKnob.PosKnob3);
end;

procedure TForm1.OtherSideClick(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if Scale.OtherSide=true then Scale.OtherSide:=false
   else Scale.OtherSide:=true;
  end;
end;


procedure TForm1.SwapColorsClick(Sender: TObject);
begin
 if theme then theme:=false else theme:=true;
 with SliderComponent1 do
  begin
   if theme then
    begin
     width                := 400;
     height               :=  40;
     BackgroundColor      := rgb(60,60,60);
     BorderColor          := rgb (255,190,10);
     BorderWidth          :=   2;
     KnobColor            := clblack;
     FocusColor1          := clwhite;
     FocusColor2          := rgb (255,190,10);
     KnobLookColor        := clwhite;
     KnobLook             := klRipped;
     KnobStyle            := ksArrowDown;
     Scale.ShowScale      := true;
     Scale.LineColor      := clsilver;
     Scale.Interval       := 10;
     Scale.MarkColor      := clsilver;
     Scale.BigMarkColor   := clwhite;
     Scale.ShowBigMark    := true;
     Scale.BigMarkInterval:= 50;
     Scale.BigMarkSize    := 1.6;
     Mark.MarkVisible     := true;
     Mark.MarkColor      := rgb (255,190,10);
     Mark.MarkPosition   := 180;
     Mark.Mark2Visible   := true;
     Mark.Mark2Position   := 20;
     Indicator.IndicatorVisible     := true;
     Indicator.IndicatorColor       := rgb (50,50,50);
     Indicator.IndicatorFontColor   := rgb (255,190,10);
     Track.TrackColor       := clsilver;
     Track.SelColor         := rgb (80,80,80);
     Track.ShowExtraColor   := true;
     Track.ExtraRangeMin    := 180;
     Track.ExtraRangeMax    := 200;
     Track.ExtraColor       := rgb (150,0,0);
     MultiKnob.ShowKnob2    := true;
     MultiKnob.ShowKnob3    := true;
     MultiKnob.ColorKnob2   := clnavy;
     MultiKnob.ColorKnob3   := rgb (120,120,120);
     MultiKnob.PosKnob2     :=  20;
     MultiKnob.PosKnob3     := 180;
    end else
    begin
     BackgroundColor      := clMenuBar;
     BorderColor          := clgray;
     BorderWidth          :=   1;
     KnobColor            := clblack;
     FocusColor1          := clblue;
     FocusColor2          := clblack;
     KnobLookColor        := clsilver;
     KnobLook             := klNormal;
     KnobStyle            := ksCircle;
     Scale.ShowScale      := false;
     Scale.LineColor      := clblack;
     Scale.Interval       := 10;
     Scale.MarkColor      := clnavy;
     Scale.BigMarkColor   := clNavy;
     Scale.ShowBigMark    := false;
     Scale.BigMarkInterval:= 50;
     Scale.BigMarkSize    := 1.5;
     Mark.MarkVisible     := false;
     Mark.Mark2Visible    := false;
     Indicator.IndicatorVisible     := false;
     Indicator.IndicatorColor       := clMoneyGreen;
     Indicator.IndicatorFontColor   := clblack;
     Track.TrackColor      := clWhite;
     Track.SelColor        := clGray;
     Track.ShowExtraColor  := false;
     Track.ExtraColor      := clred;
     MultiKnob.ShowKnob2   := false;
     MultiKnob.ShowKnob3   := false;
     MultiKnob.ColorKnob2  := cllime;
     MultiKnob.ColorKnob3  := clblue;
    end;
  end;
end;


procedure TForm1.Knob2Click(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if MultiKnob.ShowKnob2=true then MultiKnob.ShowKnob2:=false
   else MultiKnob.ShowKnob2:=true;
  end;
 RadioGroup1Click(nil);
end;


procedure TForm1.Knob3Click(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if MultiKnob.ShowKnob3=true then MultiKnob.ShowKnob3:=false
   else MultiKnob.ShowKnob3:=true;
  end;
 RadioGroup1Click(nil);
end;

procedure TForm1.SetWHClick(Sender: TObject);
begin
 try
  SliderComponent1.Width:=strtoint(SliderWidth.Text);
  SliderComponent1.Height:=strtoint(SliderHeight.Text);
  SliderComponent1.Invalidate;

 finally
 end;
end;


procedure TForm1.ExtraColorClick(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if Track.ShowExtraColor=true then Track.ShowExtraColor:=false
   else Track.ShowExtraColor:=true;
  end;
 RadioGroup1Click(nil);
end;


procedure TForm1.SelColorClick(Sender: TObject);
begin
 with SliderComponent1 do
  begin
   if Track.ShowSelRange=true then Track.ShowSelRange:=false
   else Track.ShowSelRange:=true;
  end;
end;
end.

